import React, { useState, useEffect, useMemo, useCallback } from 'react';
import { Steps } from 'antd';

const { Step } = Steps;

export default function StepDiy(props) {
  const { value, onChange, json, form } = props;
  const diyProps = useMemo(() => {
    let b = {};
    if (value && typeof value === 'object') {
      b = {
        ...value,
      };
    }
    if (json.otherProps && typeof json.otherProps === 'string') {
      try {
        let a = new Function(json.otherProps)();
        if (a) {
          return {
            ...a,
            ...b,
          };
        }
        return b;
      } catch (e) {
        console.error('Step组件 otherProps错误');
      }
    } else {
      return b;
    }
  }, [json.otherProps, value]);

  /**
   * 按姚鑫国的要求 在切换步骤时将表单的值保存起来
   * */
  useEffect(() => {
    console.log(JSON.stringify(form.getFieldsValue()));
  }, [diyProps?.StepsProps.current]);

  return (
    <div style={diyProps.outSideDivStyle}>
      <Steps {...diyProps.StepsProps}>
        {Array.isArray(diyProps.Step) &&
          diyProps.Step.map(g => {
            return <Step {...g} key={g.title} />;
          })}
      </Steps>
    </div>
  );
}
